/*
 * Copyright (c) 2013-2014, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
/*
 *  ======== Processor_dsplink.c ========
 */

/* This define must precede inclusion of any xdc header files */
#define Registry_CURDESC ti_sdo_ce_ipc_processor_desc

#include <xdc/std.h>
#include <xdc/runtime/Assert.h>
#include <xdc/runtime/Diags.h>
#include <xdc/runtime/Log.h>
#include <xdc/runtime/Registry.h>

#include <ti/sdo/ce/osal/Memory.h>
#include <ti/sdo/ce/osal/Global.h>
#include <xdc/runtime/knl/Thread.h>
#include <xdc/runtime/Gate.h>
#include <xdc/runtime/knl/GateThread.h>
#include <xdc/runtime/knl/SemThread.h>

#include <ti/sdo/ce/global/CESettings.h>

#include <sys/types.h>
#include <ti/cmem.h>

#include <ti/sdo/ce/ipc/Comm.h>
#include <ti/sdo/ce/ipc/Processor.h>

//#include <ti/ipc/HeapBufMP.h>
#include <ti/ipc/Ipc.h>
#include <ti/ipc/MessageQ.h>
#include <ti/ipc/MultiProc.h>

#include <stdio.h>  /* for printf() and getchar() */
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>

#include <errno.h>


#define Processor_defaultSharedRegionId ti_sdo_ce_ipc_dsplink__Processor_defaultSharedRegionId
#define Processor_defaultHeapId ti_sdo_ce_ipc_dsplink__Processor_defaultHeapId
#define Processor_defaultNumMsgs ti_sdo_ce_ipc_dsplink__Processor_defaultNumMsgs
#define Processor_defaultMsgSize ti_sdo_ce_ipc_dsplink__Processor_defaultMsgSize
#define Processor_commDescs ti_sdo_ce_ipc_dsplink__Processor_commDescs
#define Processor_numCommDescs ti_sdo_ce_ipc_dsplink__Processor_numCommDescs
#define Processor_loadSlave ti_sdo_ce_ipc_dsplink__Processor_loadSlave

/* Generated by .xdt file */
extern Int16 Processor_defaultSharedRegionId;
extern Int16 Processor_defaultHeapId;
extern Int32 Processor_defaultNumMsgs;
extern Int32 Processor_defaultMsgSize;
extern Processor_CommDesc Processor_commDescs[];
extern UInt32 Processor_numCommDescs;
extern Bool Processor_loadSlave;


/*
 *  ======== Processor_Obj ========
 */
typedef struct Processor_Obj {
    Int               cpuId;
    UInt16            heapId;
    String            imageName;
    String            memMapName;
    Bool              loaded;
    Processor_Attrs   attrs;
    UInt32            fileId;
    Int32             loadCallBackStatus;
    Int32             startCallBackStatus;
    Bool              useExtLoader;
} Processor_Obj;

/*
 *  ======== Processor_ATTRS ========
 */
Processor_Attrs Processor_ATTRS = {
    "dsp0",     /* cpu ID */
    0,          /* argc */
    NULL,       /* argv */
    FALSE,      /* useExtLoader */
};

#define NONE    0
#define CREATE  1
#define DELETE  2
#define EXIT    3

#define SUCCESS 1
#define FAILURE 2

/*
 *  ======== CmdObj ========
 */
typedef struct CmdObj {
    Thread_Handle     dproc;
    Processor_Handle  proc;
    Int               cmdId;
    Int               reply;

    SemThread_Handle  cmdPresent;
    SemThread_Handle  replyPresent;
    GateThread_Handle gate;
} CmdObj;


/*
 *  Memory map entry format in map text file.
 */
typedef struct MapStruct {
    UInt32 slaveVirt;
    UInt32 slavePhys;
    UInt32 masterPhys;
    UInt32 size;
    UInt32 mapMask;
    int isCached;
} MapStruct;

/* REMINDER: if you add an initialized static var, reinitialize it at cleanup */

static CmdObj dcmd = {NULL, NULL, NONE, NONE, NULL, NULL, NULL};

static Void cleanup(Void);
static Int daemon(Void);
static Int doCmd(Int cmdId, Processor_Handle proc);
static Int getCmd(Processor_Handle *proc);
static Bool procCreate(Processor_Handle proc);
static Void procDelete(Processor_Handle proc);
static Void putReply(Int status);

static Int16 perCoreHeapId(UInt32 coreId);
static Int32 perCoreNumMsgs(UInt32 coreId);
static Int32 perCoreMsgSize(UInt32 coreId);
static Int16 perCoreSharedRegionId(UInt32 coreId);
static Bool perCoreUserCreatedHeapFlag(UInt32 coreId);

Registry_Desc ti_sdo_ce_ipc_processor_desc;

static Int regInit = 0;     /* Registry_addModule() called */
static Int curInit = 0;     /* module init counter */

/*
 *  ======== Processor_create ========
 */
Processor_Handle Processor_create(String imageName, String memMap,
    Processor_Attrs *attrs)
{
    Processor_Handle proc = NULL;
    struct stat statBuf;

    Assert_isTrue(curInit == TRUE, (Assert_Id)NULL);

    Log_print3(Diags_ENTRY, "[+E] Processor_create> "
            "Enter(imageName='%s', memMap='%s', attrs=0x%x)",
            (IArg)imageName, (IArg)memMap, (IArg)attrs);

    if (attrs == NULL) {
        attrs = &Processor_ATTRS;
    }

    if (stat(imageName, &statBuf) != 0) {
        Log_print1(Diags_USER7, "[+7] Processor_create> "
                "ERROR: cannot access file %s", (IArg)imageName);
        return (NULL);
    }

    proc = Memory_alloc(sizeof(Processor_Obj), NULL);
    if (proc == NULL) {
        Log_print0(Diags_USER7, "[+7] Processor_create> "
                "ERROR: Memory_alloc failed");
        return (NULL);
    }

    proc->attrs = *attrs;
    proc->imageName = imageName;
    proc->memMapName = memMap;
    proc->loaded = FALSE;
    proc->fileId = 0xffffffff;
    proc->loadCallBackStatus = -1;
    proc->startCallBackStatus = -1;
    proc->useExtLoader = attrs->useExtLoader;

    if (doCmd(CREATE, proc) != SUCCESS) {
        Processor_delete(proc);
        return (NULL);
    }
    proc->loaded = TRUE;

    Log_print1(Diags_EXIT, "[+X] Processor_create> return (0x%x)", (IArg)proc);

    return (proc);
}


/*
 *  ======== Processor_delete ========
 */
Void Processor_delete(Processor_Handle proc)
{
    Assert_isTrue(curInit == TRUE, (Assert_Id)NULL);

    Log_print1(Diags_ENTRY, "[+E] Processor_delete> Enter(proc=0x%x)",
            (IArg)proc);

    if (proc != NULL) {
        if (proc->loaded == TRUE && dcmd.dproc != NULL) {
            doCmd(DELETE, proc);
        }

        Log_print1(Diags_USER1,
                "[+1] Processor_delete(0x%x) freeing object ...", (IArg)proc);
        Memory_free(proc, sizeof(Processor_Obj), NULL);
    }

    Log_print0(Diags_EXIT, "[+X] Processor_delete> return");
}


/*
 *  ======== Processor_init ========
 */
Void Processor_init(Void)
{
    GateThread_Params params;
    Registry_Result   result;

    /*
     *  No need to reference count for Registry_addModule(), since there
     *  is no way to remove the module.
     */
    if (regInit == 0) {
        /* Register this module for logging */
        result = Registry_addModule(&ti_sdo_ce_ipc_processor_desc,
                Processor_MODNAME);
        Assert_isTrue(result == Registry_SUCCESS, (Assert_Id)NULL);

        if (result == Registry_SUCCESS) {
            /* Set the diags mask to the CE default */
            CESettings_init();
            CESettings_setDiags(Processor_MODNAME);
        }
        regInit = 1;
    }

    if (curInit != TRUE) {
        curInit = TRUE;

        /* Semaphore with count 0, will be posted when a command is present */
        dcmd.cmdPresent = SemThread_create(0, NULL, NULL);

        /* Semaphore with count 0, will be posted when reply is ready */
        dcmd.replyPresent = SemThread_create(0, NULL, NULL);

        /*
         *  Create lock to allow only one thread at a time to send command
         *  to the daemon.
         */
        GateThread_Params_init(&params);
        dcmd.gate = GateThread_create(&params, NULL);

        if ((dcmd.cmdPresent == NULL) || (dcmd.replyPresent == NULL) ||
                (dcmd.gate == NULL)) {
            // TODO: Shouldn't we abort?
            Log_print0(Diags_USER7, "[+7] Processor_init> ERROR: cannot"
                    " create semaphores or lock");
        }

        Log_print0(Diags_USER2, "[+2] Processor_init> Ipc_start()...");

        Ipc_start();
        Log_print0(Diags_USER2, "[+2] Processor_init> "
                "... Ipc_start() done");

        if ((dcmd.dproc = Thread_create((Thread_RunFxn)daemon, NULL, NULL))
                == NULL) {
            Log_print0(Diags_USER7, "[+7] Processor_init> "
                    "ERROR: cannot create DSP daemon");
        }

        if (Thread_start(NULL) != TRUE) {
            Log_print0(Diags_USER7, "[+7] Processor_init> "
                    "ERROR: cannot start threads");
        }

        Global_atexit((Fxn)cleanup);
    }
}

/*
 *  ======== Processor_getCoreName ========
 */
String Processor_getCoreName(UInt32 id)
{
    UInt16 mpId = (UInt16)id;

    return(MultiProc_getName(mpId));
}


/*
 *  ======== Processor_getCoreId ========
 */
UInt32 Processor_getCoreId(String name)
{
    UInt16 coreId = MultiProc_getId(name);

    if (coreId == MultiProc_INVALIDID) {
        return (Processor_INVALIDID);
    }
    else {
        return ((UInt32)coreId);
    }
}

/*
 *  ======== Processor_getNumProcs ========
 */
UInt32 Processor_getNumProcs(Void)
{
    return(MultiProc_getNumProcessors());
}

/*
 *  ======== Processor_myCoreId ========
 */
UInt32 Processor_myCoreId(Void)
{
    return(MultiProc_self());
}

/*
 *  ======== Processor_getHeapId ========
 */
UInt16 Processor_getHeapId(UInt32 coreId)
{
    Int16 heapId;

    heapId = perCoreHeapId(coreId);
    if (heapId == Processor_INVALID) {
        heapId = Processor_defaultHeapId;
    }

    return(heapId);
}

/*
 *  ======== Processor_getMsgSize ========
 */
UInt32 Processor_getMsgSize(UInt32 coreId)
{
    Int32 msgSize;

    msgSize = perCoreMsgSize(coreId);
    if (msgSize == Processor_INVALID) {
        msgSize = Processor_defaultMsgSize;
    }

    return(msgSize);
}

/*
 *  ======== Processor_getNumMsgs ========
 */
UInt32 Processor_getNumMsgs(UInt32 coreId)
{
    Int32 numMsgs;

    numMsgs = perCoreNumMsgs(coreId);
    if (numMsgs == Processor_INVALID) {
        numMsgs = Processor_defaultNumMsgs;
    }

    return(numMsgs);
}

/*
 *  ======== Processor_getSharedRegionId ========
 */
UInt16 Processor_getSharedRegionId(UInt32 coreId)
{
    Int16 sharedRegionId;

    sharedRegionId = perCoreSharedRegionId(coreId);
    if (sharedRegionId == Processor_INVALID) {
        sharedRegionId = Processor_defaultSharedRegionId;
    }

    return(sharedRegionId);
}

/*
 *  ======== Processor_getUserCreatedHeapFlag ========
 */
Bool Processor_getUserCreatedHeapFlag(UInt32 coreId)
{
    return(perCoreUserCreatedHeapFlag(coreId));
}

static Int16 perCoreHeapId(UInt32 coreId)
{
    if (coreId == MultiProc_INVALIDID ||
        coreId >= Processor_numCommDescs) {

        return(Processor_INVALID);
    }

    return(Processor_commDescs[coreId].heapId);
}

static Int32 perCoreMsgSize(UInt32 coreId)
{
    if (coreId == MultiProc_INVALIDID ||
        coreId >= Processor_numCommDescs) {

        return(Processor_INVALID);
    }

    return(Processor_commDescs[coreId].msgSize);
}

static Int32 perCoreNumMsgs(UInt32 coreId)
{
    if (coreId == MultiProc_INVALIDID ||
        coreId >= Processor_numCommDescs) {

        return(Processor_INVALID);
    }

    return(Processor_commDescs[coreId].numMsgs);
}

static Int16 perCoreSharedRegionId(UInt32 coreId)
{
    if (coreId == MultiProc_INVALIDID ||
        coreId >= Processor_numCommDescs) {

        return(Processor_INVALID);
    }

    return(Processor_commDescs[coreId].sharedRegionId);
}

static Bool perCoreUserCreatedHeapFlag(UInt32 coreId)
{
    if (coreId == MultiProc_INVALIDID ||
        coreId >= Processor_numCommDescs) {

        return(FALSE);
    }

    return(Processor_commDescs[coreId].userCreatedHeap);
}



/*
 *  ======== Processor_wait ========
 */
Int Processor_wait(Processor_Handle proc)
{
    return(-1);
}

/*
 *  ======== cleanup ========
 */
static Void cleanup(Void)
{
    static CmdObj dcmdInit = {NULL, NULL, NONE, NONE, NULL, NULL, NULL};

    if (curInit != FALSE) {
        curInit = FALSE;
        if (dcmd.dproc != NULL) {
            doCmd(EXIT, NULL);
            // Thread_join(dcmd.dproc);
            Thread_delete(&dcmd.dproc); /* will do join first? */
            dcmd.dproc = NULL;
        }

        Log_print0(Diags_USER2, "[+2] Processor cleanup()> "
                "Ipc_stop()...");
        Ipc_stop();
        Log_print0(Diags_USER2, "[+2] Processor cleanup()> "
                "... Ipc_stop() complete");

        if (dcmd.cmdPresent != NULL) {
            SemThread_delete(&dcmd.cmdPresent);
            dcmd.cmdPresent = NULL;
        }

        if (dcmd.replyPresent != NULL) {
            SemThread_delete(&dcmd.replyPresent);
            dcmd.replyPresent = NULL;
        }

        if (dcmd.gate != NULL) {
            GateThread_delete(&dcmd.gate);
            dcmd.gate = NULL;
        }

        dcmd = dcmdInit;
    }
}

/*
 *  ======== procCreate ========
 */
static Bool procCreate(Processor_Handle proc)
{
    Int status = 0;
    Bool retVal;

    Log_print1(Diags_ENTRY, "[+E] Processor_create_d> Enter(proc=0x%x)",
            (IArg)proc);

    /* Create and initialize the PROC object */
    Log_print1(Diags_USER2, "[+2] Processor_create_d> "
    "Retrieving CPU ID for '%s'...", (IArg)(proc->attrs.cpuId));

    proc->cpuId = Processor_getCoreId(proc->attrs.cpuId);
    if (proc->cpuId < 0) {
        Log_print1(Diags_USER7, "[+7] Processor_create_d> "
               "Processor_getCoreId() failed: %d", proc->cpuId);
        goto fail;
    }

    retVal = TRUE;
    goto procCreate_return;

    /* TODO:[4] should try those asyncErrorHandlers that link supports?
     * (MSGQ_SetErrorHandler)
     */

fail:
    Log_print3(Diags_USER7, "[+7] Processor_create_d> "
            "Loading and starting %s server '%s' FAILED, status=[0x%x]",
            (IArg)proc->attrs.cpuId, (IArg)proc->imageName, status);

    procDelete(proc);

    retVal = FALSE;

procCreate_return:

    Log_print1(Diags_USER2, "[+2] Processor_create_d> return (%d)",
            (IArg)retVal);

    return (retVal);
}

/*
 *  ======== procDelete ========
 */
static Void procDelete(Processor_Handle proc)
{
    Log_print1(Diags_ENTRY, "[+E] Processor_delete_d> Enter (proc=0x%x)",
            (IArg)proc);

    Log_print0(Diags_EXIT, "[+X] Processor_delete_d> return");
}

/*
 *  ======== doCmd ========
 */
static Int doCmd(Int cmdId, Processor_Handle proc)
{
    Int result;
    IArg key;

    Log_print2(Diags_ENTRY, "[+E] doCmd> Enter (cmdId=%d, proc=0x%x)",
            (IArg)cmdId, (IArg)proc);

    //pthread_mutex_lock(&dcmd.gate);
    key = GateThread_enter(dcmd.gate);

    dcmd.proc = proc;
    dcmd.cmdId = cmdId;
    //pthread_cond_signal(&dcmd.cmdPresent);
    SemThread_post(dcmd.cmdPresent, NULL);

    //while (dcmd.reply == NONE) {
    //    pthread_cond_wait(&dcmd.replyPresent, &dcmd.gate);
    //}
    SemThread_pend(dcmd.replyPresent, SemThread_FOREVER, NULL);

    result = dcmd.reply;
    dcmd.reply = NONE;

    //pthread_mutex_unlock(&dcmd.gate);
    GateThread_leave(dcmd.gate, key);

    Log_print1(Diags_EXIT, "[+X] doCmd> Exit (result=%d)", (IArg)result);

    return (result);
}

/*
 *  ======== getCmd ========
 */
static Int getCmd(Processor_Handle *proc)
{
    Int result;

    Log_print1(Diags_ENTRY, "[+E] getCmd_d> Enter (proc=0x%x)", (IArg)proc);

    //pthread_mutex_lock(&dcmd.gate);

    //while (dcmd.cmdId == NONE) {
    //    pthread_cond_wait(&dcmd.cmdPresent, &dcmd.gate);
    //}
    SemThread_pend(dcmd.cmdPresent, SemThread_FOREVER, NULL);

    result = dcmd.cmdId;
    *proc = dcmd.proc;
    dcmd.cmdId = NONE;

    //pthread_mutex_unlock(&dcmd.gate);
    Log_print1(Diags_EXIT, "[+X] getCmd_d> Exit (result=%d)", (IArg)result);

    return (result);
}

/*
 *  ======== putReply ========
 */
static Void putReply(Int status)
{
    //pthread_mutex_lock(&dcmd.gate);

    dcmd.reply = status;

    //pthread_cond_signal(&dcmd.replyPresent);
    SemThread_post(dcmd.replyPresent, NULL);

    //Log_print2(Diags_USER1, "putReply(0x%x): proc = 0x%lx",
    //        (IArg)status, (IArg)(dcmd.proc));

    //pthread_mutex_unlock(&dcmd.gate);
}

/*
 *  ======== daemon ========
 */
static Int daemon(Void)
{

    Log_print0(Diags_USER1, "[+1] daemon> thread created.");

    for (;;) {
        Processor_Handle proc;

        switch (getCmd(&proc)) {
            case CREATE: {
                putReply(procCreate(proc) ? SUCCESS : FAILURE);
                break;
            }

            case DELETE: {
                /* Log_print1(Diags_USER1, "daemon(0x%x) deleting ...",
                 *   (IArg)proc);
                 */
                procDelete(proc);
                /* Log_print1(Diags_USER1, "daemon(0x%x) replying ...",
                 *   (IArg)proc);
                 */
                putReply(SUCCESS);

                break;
            }

            case EXIT: {
                //Log_print0(Diags_USER1, "daemon> thread terminating");
                putReply(SUCCESS);
                return (0);
            }

            default: {
                break;
            }
        }
    }
}
